"use strict";
/* eslint-disable functional/type-declaration-immutability */
/* eslint-disable functional/prefer-immutable-types */
Object.defineProperty(exports, "__esModule", { value: true });
exports.fpTsEffectType = exports.effects = void 0;
const common_1 = require("./common");
// Note: `Lazy` deliberately excluded even though it has the same signature as `IO`, its semantics
// don't imply impurity like IO.
exports.effects = [
    "IO",
    "IOEither",
    "IOOption",
    "ReaderTask",
    "ReaderTaskEither",
    "StateReaderTaskEither",
    "Task",
    "TaskEither",
    "TaskOption",
    "TaskThese",
];
const fpTsEffectTypeParameter = (effectName, effectType) => {
    // eslint-disable-next-line functional/no-conditional-statements
    if (effectName === "IO") {
        const signatures = effectType.getCallSignatures();
        const signature = signatures[0];
        // eslint-disable-next-line functional/no-conditional-statements
        if (signatures.length !== 1 || signature === undefined) {
            return undefined;
        }
        return signature.getReturnType();
    }
    // TODO extract the type param from other effect types.
    return undefined;
};
const fpTsEffectType = (type) => {
    const symbolName = (0, common_1.typeSymbolName)(type);
    // eslint-disable-next-line functional/no-conditional-statements
    if (symbolName === undefined || !exports.effects.includes(symbolName)) {
        return undefined;
    }
    return {
        effectType: type,
        effectName: symbolName,
        effectTypeParameter: fpTsEffectTypeParameter(symbolName, type),
    };
};
exports.fpTsEffectType = fpTsEffectType;
