"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable functional/prefer-immutable-types */
const common_1 = require("./common");
/**
 * An ESLint rule to ban unsafe enum assignments.
 */
// eslint-disable-next-line total-functions/no-unsafe-readonly-mutable-assignment
const noUnsafeEnumAssignment = (0, common_1.createRule)({
    name: "no-unsafe-enum-assignment",
    meta: {
        type: "problem",
        docs: {
            description: "Bans unsafe enum assignment.",
            recommended: "error",
        },
        messages: {},
        schema: [],
        deprecated: true,
    },
    // eslint-disable-next-line functional/functional-parameters
    create: () => ({}),
    defaultOptions: [],
});
exports.default = noUnsafeEnumAssignment;
